/*
 * Drawer
 *
 * Index
 * - Overlay
 * - Drawer
 * - Position
 * - Content
 * - Header
 * - Actions
 * - Title
 * - Body
 * - Open state
 */

/**
 * @prop --background: background color of the content of the drawer.
 * @prop --color: text color of the content of the drawer.
 * @prop --header-icon: color of the header icons.
 * @prop --header-color: color of the header text.
 * @prop --header-background: color of the header background.
 * @prop --header-delimiter: size of the border delimiter (in px) at the bottom of the header
 * @prop --back-chevron-color: color of back chevron
 * @prop --max-height: max-height of the drawer for bottom position
 * @prop --z-index: The z-index of the Drawer.
 */

/* OVERLAY
 -------------------- */

:host {
  --background: var(--road-surface);
  --color: var(--road-on-surface);
  --header-icon: var(--road-on-surface);
  --header-color: var(--road-on-surface);
  --header-background: var(--road-surface);
  --header-delimiter: 0;
  --back-chevron-color: var(--road-icon);
  --max-height: auto;
  --z-index: 10;

  position: fixed;
  top: 0;
  left: 0;
  z-index: var(--z-index);
  display: flex;
  justify-content: flex-start;
  width: 100%;
  height: 100%;
  overflow: hidden;
  font-family: var(--road-font, sans-serif);
  line-height: 1.5;
  color: var(--color);
  visibility: hidden !important;
  opacity: 0;
  transition: opacity 0.15s linear, visibility 0.15s;
}

/* OVERLAY
 -------------------- */

.drawer-overlay {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  display: block;
  touch-action: none;
  cursor: pointer;
  background: var(--road-overlay);
}

/* DRAWER
 -------------------- */

.drawer-dialog {
  position: relative;
  width: 100%;
  pointer-events: none;
  transition: transform 0.3s ease-out;
  transform: translateX(-100%);
}

/* POSITION
 -------------------- */

:host(.drawer-right) {
  justify-content: flex-end;
}

:host(.drawer-right) .drawer-dialog {
  transform: translateX(100%);
}

/**
 * Bottom position
 */

:host(.drawer-bottom) {
  align-items: flex-end;
}

:host(.drawer-bottom) .drawer-dialog {
  width: 100%;
  max-height: var(--max-height);
  transform: translateY(100%);
}

:host(.drawer-bottom) .drawer-content {
  height: auto;
}

/* CONTENT
 -------------------- */

.drawer-content {
  position: relative;
  display: flex;
  flex-direction: column;
  width: 100%;
  height: 100vh;
  pointer-events: auto;
  background-color: var(--background);
  background-clip: padding-box;
  box-shadow: var(--road-elevation-hight);
}

/* HEADER
 -------------------- */

.drawer-header {
  display: flex;
  flex-shrink: 0;
  align-items: center;
  justify-content: flex-end;
  height: 3.5rem;
  color: var(--header-color);
  background: var(--header-background);
  border-color: var(--road-grey-300);
  border-style: solid;
  border-width: var(--header-delimiter);
}

.drawer-header road-icon {
  flex-shrink: 0;
  color: var(--header-icon);
}

.drawer-footer {
  padding: var(--road-spacing-05);
  background-color: var(--road-surface);
}

/**
 * Header inverse colors
 */

.drawer-header-inverse {
  --header-icon: var(--road-on-primary);
  --header-color: var(--road-on-primary);
  --header-background: var(--road-primary-variant);

  margin-bottom: 2.5rem;
}

/* ACTIONS
 -------------------- */

.drawer-action,
.drawer-close {
  display: flex;
  align-items: center;
  justify-content: center;
  height: 3.5rem;
  padding: 0.5rem;
  font-family: inherit;
  font-size: 0.875rem;
  color: inherit;
  cursor: pointer;
  background: transparent;
  border: 0;
  appearance: none;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

.drawer-header:not(.drawer-header-inverse) .drawer-action road-icon {
  color: var(--back-chevron-color);
}

.drawer-action ~ .drawer-title,
.drawer-close ~ .drawer-title {
  padding-left: 0;
}

.drawer-action-left,
.drawer-close-left {
  margin-right: auto;
}

/* TITLE
 -------------------- */

.drawer-title {
  display: flex;
  flex-grow: 1;
  align-items: center;
  justify-content: center;
  height: 3.5rem;
  padding-left: 3.5rem;
  margin: 0;
  font-size: var(--road-body-medium);
}

/* BODY
 -------------------- */

.drawer-body {
  overflow-y: auto;
}

:host(.drawer-right) .drawer-body,
:host(.drawer-left) .drawer-body {
  height: calc(100vh - 3.5rem);
}

.drawer-inner {
  padding: 0 1rem 2.5rem;
}

@media (min-width: 768px) {

  .drawer-inner {
    padding: 0 2rem 2.5rem;
  }

  .drawer-body {
    padding: 0 var(--road-spacing-08) var(--road-spacing-05);
  }

  .drawer-footer {
    padding: var(--road-spacing-05) var(--road-spacing-08);
  }
}

/* OPEN STATE
 -------------------- */

:host(.drawer-open) {
  visibility: visible !important;
  opacity: 1;
}

:host(.drawer-open) .drawer-dialog {
  transform: none;
}
